-- defining list of paladin auras (for sanctified retribution, since any aura could give the buff)
local PALADIN_AURA_LIST = {}
PALADIN_AURA_LIST[GetSpellInfo(465)] = true
PALADIN_AURA_LIST[GetSpellInfo(7294)] = true
PALADIN_AURA_LIST[GetSpellInfo(19746)] = true
PALADIN_AURA_LIST[GetSpellInfo(19876)] = true
PALADIN_AURA_LIST[GetSpellInfo(19888)] = true
PALADIN_AURA_LIST[GetSpellInfo(19891)] = true
PALADIN_AURA_LIST[GetSpellInfo(32223)] = true

-- defining list of paladin auras (for sanctified retribution, since any aura could give the buff)
local ROGUE_POISON_LIST = {}
ROGUE_POISON_LIST[GetSpellInfo(57970)] = true -- deadly
ROGUE_POISON_LIST[GetSpellInfo(57965)] = true -- instant
ROGUE_POISON_LIST[GetSpellInfo(57978)] = true -- wound 
ROGUE_POISON_LIST[GetSpellInfo(57981)] = true -- anesthetic

ShadowGreenLight.upgradeDb = {
	-------------------------------------
	-- ShadowWeave
	["ShadowWeave"] = {
		name = GetSpellInfo(15257),
		maxCount = 5,
		upgradePerStack = 2,
		type = "Shadow Weaving",
		detectionUnit = "player",
		detectionType = "buff",
		upgradeType = "dmg",
	},
	-------------------------------------
	-- Talent-based upgrades
	["Improved Scorch"] = {
		name = GetSpellInfo(11095),
		talentName = GetSpellInfo(11095),
		talentTab = 2,
		talentIndex = 11,
		maxCount = 1,
		upgradePerStack = 5,
		type = "Spell Critical Strike Chance Debuff",
		detectionUnit = "target",
		detectionType = "debuff",
		upgradeType = "crit",
	},
	["Improved Shadow Bolt"] = {
		name = GetSpellInfo(18275),
		talentName = GetSpellInfo(17803),
		talentTab = 3,
		talentIndex = 1,
		maxCount = 1,
		upgradePerTalentRank = {
			[1] = 1,
			[2] = 2,
			[3] = 3,
			[4] = 4,
			[5] = 5,
		},
		type = "Spell Critical Strike Chance Debuff",
		detectionUnit = "target",
		detectionType = "debuff",
		upgradeType = "crit",
	},
	["Winter's Chill"] = {
		name = GetSpellInfo(11180),
		talentName = GetSpellInfo(11180),
		talentTab = 3,
		talentIndex = 18,
		maxCount = 5,
		upgradePerStack = 1,
		type = "Spell Critical Strike Chance Debuff",
		detectionUnit = "target",
		detectionType = "debuff",
		upgradeType = "crit",
	},
	["Totem of Wrath"] = {
		name = GetSpellInfo(57722),
		talentName = GetSpellInfo(57722),
		talentTab = 1,
		talentIndex = 22,
		maxCount = 1,
		upgradePerStack = 3,
		type = "Critical Strike Chance Taken Debuff",
		detectionUnit = "target",
		detectionType = "debuff",
		upgradeType = "crit",
	},
	["Heart of the Crusader"] = {
		name = GetSpellInfo(20337),
		talentName = GetSpellInfo(20337),
		talentTab = 3,
		talentIndex = 4,
		maxCount = 1,
		upgradePerTalentRank = {
			[1] = 1,
			[2] = 2,
			[3] = 3,
		},
		type = "Critical Strike Chance Taken Debuff",
		detectionUnit = "target",
		detectionType = "debuff",
		upgradeType = "crit",
	},
	["Arcane Empowerment"] = {
		name = GetSpellInfo(31579),
		talentName = GetSpellInfo(31579),
		talentTab = 1,
		talentIndex = 21,
		maxCount = 1,
		upgradePerTalentRank = {
			[1] = 1,
			[2] = 2,
			[3] = 3,
		},
		type = "Percentage Damage Increase",
		detectionUnit = "target",
		detectionType = "debuff",
		upgradeType = "dmg",
	},
	["Master Poisoner"] = {
		name = GetSpellInfo(58410),
		affectingAuraNames = ROGUE_POISON_LIST,
		providerIsSignificant = true,
		talentName = GetSpellInfo(58410),
		talentTab = 1,
		talentIndex = 23,
		maxCount = 1,
		upgradePerTalentRank = {
			[1] = 1,
			[2] = 2,
			[3] = 3,
		},
		type = "Critical Strike Chance Taken Debuff",
		detectionUnit = "target",
		detectionType = "debuff",
		upgradeType = "crit",
	},
	["Moonkin Aura"] = {
		name = GetSpellInfo(24907),
		talentName = GetSpellInfo(24858),
		talentTab = 1,
		talentIndex = 18,
		maxCount = 1,
		upgradePerStack = 5,
		type = "Spell Critical Strike Chance Buff",
		detectionUnit = "player",
		detectionType = "buff",
		upgradeType = "crit",
	},
	["Elemental Oath"] = {
		name = GetSpellInfo(53414),
		talentName = GetSpellInfo(53414),
		talentTab = 1,
		talentIndex = 19,
		maxCount = 1,
		upgradePerTalentRank = {
			[1] = 3,
			[2] = 5,
		},
		type = "Spell Critical Strike Chance Buff",
		detectionUnit = "player",
		detectionType = "buff",
		upgradeType = "crit",
	},
	["Ferocious Inspiration"] = {
		name = GetSpellInfo(34455),
		talentName = GetSpellInfo(34455),
		talentTab = 1,
		talentIndex = 17,
		maxCount = 1,
		upgradePerTalentRank = {
			[1] = 1,
			[2] = 2,
			[3] = 3,
		},
		type = "Percentage Damage Increase",
		detectionUnit = "player",
		detectionType = "buff",
		upgradeType = "dmg",
	},
	["Sanctified Retribution"] = {
		name = GetSpellInfo(31869),
		affectingAuraNames = PALADIN_AURA_LIST,
		providerIsSignificant = true,
		talentName = GetSpellInfo(31869),
		talentTab = 3,
		talentIndex = 14,
		maxCount = 1,
		upgradePerStack = 3,
		type = "Percentage Damage Increase",
		detectionUnit = "player",
		detectionType = "buff",
		upgradeType = "dmg",
	},
	-------------------------------------
	-- Player-based bonus
	["Tricks of the Trade"] = {
		name = GetSpellInfo(57934),
		upgradePerStack = 6,
		type = "Tricks of the Trade",
		detectionUnit = "player",
		detectionType = "buff",
		isBonus = true,
		upgradeType = "dmg",
	},
	["Wild Magic"] = {
		name = GetSpellInfo(53909),
		upgradePerStack = 200/45.91,
		type = "Wild Magic",
		detectionUnit = "player",
		detectionType = "buff",
		isBonus = true,
		upgradeType = "crit",
	},
	-------------------------------------
	-- Encounter specific bonus
	-- Malygos
	["Power Spark"] = {
		name = GetSpellInfo(56152),
		upgradePerStack = 50,
		type = "Encounter Specific - Malygos",
		detectionUnit = "player",
		detectionType = "debuff",
		multipleAuraInstanceStack = true,	-- Set to true only if there can be multiple auras with same name and effects stacks
		isBonus = true,
		upgradeType = "dmg",
	},
	-- Naxxramas
	["Fungal Creep"] = {
		name = GetSpellInfo(29232),
		upgradePerStack = 50,
		type = "Encounter Specific - Loatheb",
		detectionUnit = "player",
		detectionType = "debuff",
		isBonus = true,
		upgradeType = "crit",
	},
	["Negative Charge"] = {
		name = GetSpellInfo(39091),
		upgradePerStack = 10,
		type = "Encounter Specific - Thaddius",
		detectionUnit = "player",
		detectionType = "debuff",
		isBonus = true,
		hasToBeStackable = true,	-- Only set this attribute to true if competing with another non-stackable aura with same name
		upgradeType = "dmg",
	},
	["Positive Charge"] = {
		name = GetSpellInfo(39089),
		upgradePerStack = 10,
		type = "Encounter Specific - Thaddius",
		detectionUnit = "player",
		detectionType = "debuff",
		isBonus = true,
		hasToBeStackable = true,	-- Only set this attribute to true if competing with another non-stackable aura with same name
		upgradeType = "dmg",
	},
	-- Ulduar
	["Unstable Sun Beam"] = {
		name = GetSpellInfo(62243),
		upgradePerStack = 5,
		type = "Encounter Specific - Freya",
		detectionUnit = "player",
		detectionType = "buff",
		isBonus = true,
		upgradeType = "dmg",
	},
	["Shadow Crash"] = {
		name = GetSpellInfo(63277),
		upgradePerStack = 100,
		type = "Encounter Specific - Vezax",
		detectionUnit = "player",
		detectionType = "debuff",
		isBonus = true,
		upgradeType = "dmg",
	},
	["Rune of Power"] = {
		name = GetSpellInfo(64320),
		upgradePerStack = 50,
		type = "Encounter Specific - Iron Council",
		detectionUnit = "player",
		detectionType = "buff",
		isBonus = true,
		upgradeType = "dmg",
	},
	["Sara's fervor"] = {
		name = GetSpellInfo(63138),
		upgradePerStack = 20,
		type = "Encounter Specific - Yogg Saron",
		detectionUnit = "player",
		detectionType = "debuff",
		isBonus = true,
		upgradeType = "dmg",
	},
	-- Trial of the Crusader
	["Empowered Light"] = {
		name = GetSpellInfo(67218),
		upgradePerStack = 100,
		type = "Encounter Specific - Valkyr Twins",
		detectionUnit = "player",
		detectionType = "buff",
		isBonus = true,
		upgradeType = "dmg",
	},
	["Empowered Darkness"] = {
		name = GetSpellInfo(67215),
		upgradePerStack = 100,
		type = "Encounter Specific - Valkyr Twins",
		detectionUnit = "player",
		detectionType = "buff",
		isBonus = true,
		upgradeType = "dmg",
	},
	-------------------------------------
	-- Gear-specific upgrade
	["Nevermelting Ice Crystal"] = {
		name = GetSpellInfo(71563),
		upgradePerStack = 184/45.91,
		type = "Trinket proc - Nevermelting Ice Crystal",
		detectionUnit = "player",
		detectionType = "buff",
		isBonus = true,
		upgradeType = "crit",
	},
	-----------------------------
	-- Test purposes
--[[	["Weakened Soul"] = {
		name = GetSpellInfo(6788),
		upgradePerStack = 10,
		type = "Encounter Specific - Test",
		detectionUnit = "player",
		detectionType = "debuff",
		isBonus = true,
		multipleAuraInstanceStack = true,	-- Set to true only if there can be multiple auras with same name and effects stacks
		upgradeType = "dmg",
	},
	["Renew"] = {
		name = GetSpellInfo(139),
		upgradePerStack = 30,
		type = "Encounter Specific - Test2",
		detectionUnit = "player",
		detectionType = "buff",
		isBonus = true,
		multipleAuraInstanceStack = true,	-- Set to true only if there can be multiple auras with same name and effects stacks
		upgradeType = "crit",
	},]]--
}